#include "dialogoeleccion.h"


//Pegar esto cuando se regenere dialogoeleccion generado
//IMPLEMENT_CLASS (DialogoEleccionGenerado, wxDialog)

IMPLEMENT_CLASS (DialogoEleccion, DialogoEleccionGenerado)

DialogoEleccion::DialogoEleccion (wxWindow *padre) : 
	DialogoEleccionGenerado ( padre, -1, "Elija la seal")
{
}

void DialogoEleccion::CargarDatos (map<string, int> datos)
{
	/*	Se cargan las cadenas de los nombres de seal
		en una lista de la cual el usuario
		elegir una de ellas. El programa devuelve la posicin
		que corresponde a esa seal */
		
		map<string, int>::iterator i;
		int posDeInsercion=0;		
		for (i=datos.begin(); i!=datos.end(); i++)
		{
			/*	Este paso es intermedio, porque wxString no
				aceptar referencias a strings*/
			string intermedia (i->first);
			wxString cadena_a_mostrar=intermedia.c_str();
			
			listaSenales->Insert (cadena_a_mostrar, posDeInsercion++);
		}
		listaSenales->SetSelection(0);
		wxLogMessage ("Se han cargado %i senales", posDeInsercion);
		posicion_elegida = -1;
}
void DialogoEleccion::SetTipoDeDialogo(int tipo)
{
	switch (tipo) {
		case DIALOGO_ENTRADAS :
			{
				SetTitle ("Elija la seal de entrada");
				break;
			}
		case DIALOGO_SALIDAS :
			{
				SetTitle ("Elija la seal de salida");
				break;
			}
		} /* Fin del case */
		return ;
}
void DialogoEleccion::SetNombre ( wxString nombreDelElemento )
{
	lblNombre->SetLabel ("Nombre del elemento:"+nombreDelElemento);
}
wxString  DialogoEleccion::GetSenalElegida()
{
	wxString cadena_elegida = listaSenales->GetStringSelection();
	
	return cadena_elegida;
}
void DialogoEleccion::OnOk		(wxCommandEvent& evento)
{
	/*	El codigo devuelto coincide con el id del boton OK. No
		es obligatorio, pero lo que veran los llamadores ser
		este valor cuando acabemos el cuadro modal */
	EndModal(ID_OK);
}

BEGIN_EVENT_TABLE(DialogoEleccion, DialogoEleccionGenerado)
	EVT_BUTTON (ID_OK, 	DialogoEleccion::OnOk)
END_EVENT_TABLE()
