#include "dialogoelectroiman.h"
#include "dialogo.h"
#include "constantes.h"

IMPLEMENT_CLASS (DialogoElectroiman, Dialogo)
DialogoElectroiman::DialogoElectroiman()
{
	Init();
}

DialogoElectroiman::DialogoElectroiman ( 	wxWindow* ventanaPadre, wxWindowID id,
							const wxString& titulo,
							const wxPoint&  posicion,
							const wxSize&   tam,
							long  			estilo ) 
{
		Init();
		Dialogo::Create (ventanaPadre, id, titulo, posicion, tam, estilo);
}

		
void DialogoElectroiman::Init()
{
	/*	Aqui se inicializan las variables */
}


void DialogoElectroiman::ConstruirControles()
{
	/*	Se crean los contenedores */
	contenedorCentral	=	new wxBoxSizer	(wxVERTICAL);
	
    
    /*	Ahora se van construyendo los controles y aadiendo a sus
    	correspondientes contenedores de arriba a abajo*/	
	contenedorReposo		=	new wxBoxSizer	 (wxHORIZONTAL);
	contenedorActivacion	=	new wxBoxSizer	 (wxHORIZONTAL);
	
	
	
	/* Se construye la fila para cuando el pulsador esta activado*/
	
	lblVoltajeReposo = 	new wxStaticText (this, wxID_STATIC, 
		wxT("Cuando el electroiman recibe "),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorReposo->Add (lblVoltajeReposo,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	wxString voltajeEnReposoPorDefecto="0";
	spnVReposo = new wxSpinCtrl (this, ID_VOLTAJE_REPOSO_ELECTROIMAN, 
		voltajeEnReposoPorDefecto, wxDefaultPosition, wxSize(60,-1),
		wxSP_ARROW_KEYS, VOLTAJE_MINIMO, VOLTAJE_MAXIMO, VOLTAJE_EN_REPOSO);	
	contenedorReposo->Add (spnVReposo,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
		
		
	lblMagnetismoReposo = new wxStaticText (this, wxID_STATIC, 
		wxT(" el magnetismo esta"),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorReposo->Add (lblMagnetismoReposo,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	
	wxString opciones1[]= {
		wxT("activado"), wxT("desactivado")
	};
	chcMagnetismoReposo = new wxChoice (this, ID_MAGNETISMO_REPOSO_ELECTROIMAN, 
		wxDefaultPosition, wxSize(60,-1), WXSIZEOF(opciones1), 
		opciones1, ESTILO );
	chcMagnetismoReposo->SetStringSelection ("desactivado");
	contenedorReposo->Add (chcMagnetismoReposo,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	
	/*	Fin de fila*/	
		
	/* Se crea ahora la fila con los controles para el voltaje de activacion*/
	lblVoltajeActivacion = 	new wxStaticText (this, wxID_STATIC, 
		wxT("Cuando el electroiman recibe "),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorActivacion->Add (lblVoltajeActivacion,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	wxString voltajeEnActivacionPorDefecto="5";
	spnVActivacion = new wxSpinCtrl (this, ID_VOLTAJE_REPOSO_ELECTROIMAN, 
		voltajeEnActivacionPorDefecto, wxDefaultPosition, wxSize(60,-1),
		wxSP_ARROW_KEYS, VOLTAJE_MINIMO, VOLTAJE_MAXIMO, VOLTAJE_EN_REPOSO);	
	contenedorActivacion->Add (spnVActivacion,
		wxSizerFlags(1).Left().Border (wxALL, 5) );
	
	
	lblMagnetismoActivo = new wxStaticText (this, wxID_STATIC, 
		wxT(" el magnetismo esta"),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorActivacion->Add (lblMagnetismoActivo,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	wxString opciones2[]= {
		wxT("activado"), wxT("desactivado")
	};
	chcMagnetismoActivacion = new wxChoice 
		(this, ID_MAGNETISMO_ACTIVACION_ELECTROIMAN, 
		wxDefaultPosition, wxSize(60,-1), WXSIZEOF(opciones2), 
		opciones2, ESTILO );
	chcMagnetismoActivacion->SetStringSelection ("activado");
	contenedorActivacion->Add (chcMagnetismoActivacion,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	
	
	contenedorCentral->Add (contenedorReposo,
		wxSizerFlags(1).Left().Border (wxALL, 5) );
	contenedorCentral->Add (contenedorActivacion,
		wxSizerFlags(1).Left().Border (wxALL, 5) );
	
	/*Fin de la fila central*/
	
	/*	Ahora que ya se tienen los controles centrales, se incrustan
		en el cuadro de dialogo basico estandar */
	
	ConstruirCuadroDeDialogo (contenedorCentral);     
}

/*************************************************/
/* Implementacion de los metodos getter y setter */
/*************************************************/

void DialogoElectroiman::getPropiedades ( Elemento* elemento )
{
	Electroiman* e = (Electroiman*) elemento;
	
	TransferirDeNombreDeElementoAControl (elemento);
	
	/*	Y los controles numricos adoptan el valor de los voltajes respectivos
		del elemento pasado */
	TransferirDeVoltajeASpin ( spnVReposo, e->getVoltajeEntradaReposo() );
	TransferirDeVoltajeASpin ( spnVActivacion, e->getVoltajeEntradaActivacion() );
		
	bool conexionReposo 	=	e->getMagSalidaReposo()->getValor();
	
	if (conexionReposo == true )
	{
		chcMagnetismoReposo->SetStringSelection ("activado");
		/*	Forzamos la revision del metodo siguiente (que comprueba que el electroiman
			no este siempre activado */
		wxCommandEvent eventoFicticio;
		this->OnCReposoActualizado (eventoFicticio);
	}
}

void DialogoElectroiman::setPropiedades ( Elemento* elemento )
{
	Electroiman* e = (Electroiman*) elemento;
	
	
	/*	Se van recuperando las seales que afectan al elemento y se
		modifican sus valores con los que el cuadro de dilogo tiene
		en este momento*/
	TransferirDeControlANombreDeElemento (elemento);
	TransferirDeSpinAVoltaje (spnVReposo, e->getVoltajeEntradaReposo());
	TransferirDeSpinAVoltaje (spnVActivacion, e->getVoltajeEntradaActivacion() );
	
	Magnetismo* mReposo		= e->getMagSalidaReposo				();
	Magnetismo* mActivacion = e->getMagSalidaActivacion			();
	
	/*	Empezamos a modificar los valores que almacena el elemento...*/
	
	
	wxString cadenaMagnetismoEnReposo;
	cadenaMagnetismoEnReposo= chcMagnetismoReposo->GetStringSelection();
	
	int comparacion = cadenaMagnetismoEnReposo.Cmp ("activado");
	
	if (comparacion==0)
	{
		mReposo->setValor		(true);
		mActivacion->setValor 	(false);
	}
	else 
	{
		mReposo->setValor		(false);
		mActivacion->setValor 	(true);
	}
	
}		
/*************************************************/
/*	Fin de implementacion de los getter y setter */		
/*************************************************/


/************************Implementacion de gestion de eventos *************/

void DialogoElectroiman::OnCReposoActualizado ( wxCommandEvent& evento )
{
	wxString cadena = chcMagnetismoReposo->GetStringSelection();
	int codigo = cadena.Cmp ("activado");
	if ( codigo==0)
	{
		//wxLogMessage ("Activado!");
		chcMagnetismoActivacion->SetSelection (1);
	}
	else 
	{
		//wxLogMessage ("Desactivado!");
		chcMagnetismoActivacion->SetSelection (0);
	}
}

void DialogoElectroiman::OnCActivacionActualizado ( wxCommandEvent& evento )
{
	wxString cadena = chcMagnetismoActivacion->GetStringSelection();
	int codigo = cadena.Cmp ("activado");
	if ( codigo==0)
	{
		//wxLogMessage ("Activado!");
		chcMagnetismoReposo->SetSelection (1);
	}
	else 
	{
		//wxLogMessage ("Desactivado!");
		chcMagnetismoReposo->SetSelection (0);
	}
}

BEGIN_EVENT_TABLE(DialogoElectroiman, wxDialog)
	//EVT_UPDATE_UI( ID_MAGNETISMO_REPOSO, DialogoElectroiman::OnCReposoActualizado )
	//EVT_UPDATE_UI( ID_MAGNETISMO_ACTIVACION, DialogoElectroiman::OnCActivacionActualizado )
	EVT_CHOICE	 ( ID_MAGNETISMO_REPOSO_ELECTROIMAN, DialogoElectroiman::OnCReposoActualizado )
	EVT_CHOICE	 ( ID_MAGNETISMO_ACTIVACION_ELECTROIMAN, DialogoElectroiman::OnCActivacionActualizado )
END_EVENT_TABLE()
