/*	Fichero dialogomotor.h
	
	Contiene el interfaz para el cuadro de dialogo que permite configurar
	un motor
	
	Ultima actualizacion: Lunes 30-10-2006
*/


#ifndef _dialogomotor_h
#define _dialogomotor_h

#include "wx/wx.h"
#include "wx/statline.h"
#include "wx/spinctrl.h"
#include "wx/valgen.h"
/*	Este fichero es necesario para que el cuadro de dialogo pueda manejar
	los mismos tipos de seales que manejan los elementos */
#include "senal.h"
#include "constantes.h"
#include "dialogo.h"
#include "motor.h"


/* Identificadores numricos asignados a los botones del cuadro de dialogo*/
enum {
		ID_GIRO_ANTIHORARIO=8050,
		ID_GIRO_HORARIO,
		ID_GIRO_REPOSO ,
		ID_RPM , 
		ID_VOLTAJE_GIRO_ANTIHORARIO ,
		ID_VOLTAJE_GIRO_HORARIO ,
		ID_VOLTAJE_GIRO_REPOSO,
		ID_DIALOGO_MOTOR
};

class DialogoMotor : public Dialogo
{
	DECLARE_CLASS (DialogoMotor)
	DECLARE_EVENT_TABLE()
	public: 
		DialogoMotor ();
		DialogoMotor ( 	wxWindow* ventanaPadre, wxWindowID id=ID_DIALOGO_MOTOR,
							const wxString& titulo= wxT ("Configurar motor"),
							const wxPoint&  posicion=wxDefaultPosition,
							const wxSize&   tam=wxDefaultSize,
							long  			estilo=wxCAPTION | 
													wxRESIZE_BORDER |
													wxSYSTEM_MENU );

		
		void ConstruirControles();
		void Init ();
		//bool Create (		wxWindow* ventanaPadre, wxWindowID id=ID_DIALOGO_PULSADOR,
//							const wxString& caption= wxT ("Configurar pulsador"),
//							const wxPoint&  posicion=wxDefaultPosition,
//							const wxSize&   tam=wxDefaultSize,
//							long  			style=wxCAPTION | 
//													wxRESIZE_BORDER |
//													wxSYSTEM_MENU );	
		/* Metodos getter y setter */
		
		/*	Lee el nombre y valores del elemento y los representa en
		el cuadro de dilogo */
		virtual void getPropiedades ( Elemento* elemento );
	
		/*	Hace que un elemento adquiera las propiedades del dilogo */
		virtual void setPropiedades ( Elemento* elemento );
		
		
		void 		OnCReposoActualizado ( wxCommandEvent& evento  );

		void 		OnCActivacionActualizado ( wxCommandEvent& evento  );
	private:
		char	nombreElemento[MAX_LONG_NOMBRE_ELEMENTO];
	
	
		wxBoxSizer*	contenedorCentral;
		
		wxStaticLine *lnSeparador1;
		wxStaticLine *lnSeparador2;
		
	    wxStaticText *lblVoltajeGiroHorario;
		wxStaticText *lblGiroHorario;
		wxStaticText *lblVoltajeReposo;
		wxStaticText *lblGiroReposo;
		wxStaticText *lblVoltajeGiroAntihorario;
		wxStaticText *lblGiroAntihorario;
		wxStaticText *lblGiroRPM;
		    
	    wxSpinCtrl *spnVoltajeGiroHorario;
		wxSpinCtrl *spnVoltajeReposo;
		wxSpinCtrl *spnVoltajeGiroAntihorario;
		wxSpinCtrl *spnRPM;
		
	    wxChoice *chcGiroHorario;
	    wxChoice *chcGiroReposo;
	    wxChoice *chcGiroAntihorario;
};

#endif
