/*	Fichero dialogoreed.h
	
	Contiene el interfaz para el cuadro de dialogo que permite configurar
	un pulsador	
	
	Ultima actualizacion: Viernes 2-11-2006
*/


#ifndef _dialogoreed_h
#define _dialogoreed_h

#include "wx/wx.h"
#include "wx/statline.h"
#include "wx/spinctrl.h"
#include "wx/valgen.h"
/*	Este fichero es necesario para que el cuadro de dialogo pueda manejar
	los mismos tipos de seales que manejan los elementos */
#include "senal.h"
#include "constantes.h"
#include "dialogo.h"
#include "reed.h"


/* Identificadores numricos asignados a los botones del cuadro de dialogo*/
enum {
	ID_DIALOGO_REED=8300,
	ID_VOLTAJE_ACTIVACION_REED,	ID_VOLTAJE_REPOSO_REED, 
	ID_CONEXION_REPOSO_REED, ID_CONEXION_ACTIVACION_REED
};

class DialogoReed : public Dialogo
{
	DECLARE_CLASS (DialogoReed)
	DECLARE_EVENT_TABLE()
	public: 
		DialogoReed ();
		DialogoReed ( 	wxWindow* ventanaPadre, wxWindowID id=ID_DIALOGO_REED,
							const wxString& titulo= wxT ("Configurar reed"),
							const wxPoint&  posicion=wxDefaultPosition,
							const wxSize&   tam=wxDefaultSize,
							long  			estilo=wxCAPTION | 
													wxRESIZE_BORDER |
													wxSYSTEM_MENU );

		
		void ConstruirControles();
		void Init ();
		//bool Create (		wxWindow* ventanaPadre, wxWindowID id=ID_DIALOGO_REED,
//							const wxString& caption= wxT ("Configurar pulsador"),
//							const wxPoint&  posicion=wxDefaultPosition,
//							const wxSize&   tam=wxDefaultSize,
//							long  			style=wxCAPTION | 
//													wxRESIZE_BORDER |
//													wxSYSTEM_MENU );	
		/* Metodos getter y setter */
		
		/*	Lee el nombre y valores del elemento y los representa en
		el cuadro de dilogo */
		virtual void getPropiedades ( Elemento* elemento );
	
		/*	Hace que un elemento adquiera las propiedades del dilogo */
		virtual void setPropiedades ( Elemento* elemento );
		
		/*	Se sobrecargan los metodos del nombre para permitir el uso de
			cadenas al estilo C y al estilo wx */
		void		setCNombre				( char* nombre );
		char*		getCNombre				();
		void		setNombre				( wxString nombre );
		wxString	getNombre				();
		
		void 		setConexionReposo 		( bool cReposo );
		bool		getConexionReposo		();
		
		void 		setConexionActivacion	( bool cActivacion );
		bool		getConexionActivacion	();
		
		void 		setVoltajeReposo 		( int vReposo );
		int			getVoltajeReposo		();
		
		void 		setVoltajeActivacion	( int vActivacion );
		int			getVoltajeActivacion	();
		
		
		void 		OnCReposoActualizado ( wxCommandEvent& evento  );

		void 		OnCActivacionActualizado ( wxCommandEvent& evento  );
	private:
		
		/*	Estos nombres de variable no son del todo representativos,
			ya que el usuario puede invertir los valores y escribir que
			por ejemplo 0V es el voltaje que el pulsador emite cuando se
			pulsa. Se usan estos nombres porque por defecto se usaran
			0V para el reposo y "false" para el estado no-conectado*/
		bool 	conexionReposo		;
		bool 	conexionActivacion	;	
		int		voltajeReposo		;
		int		voltajeActivacion	;
		char	nombreElemento[MAX_LONG_NOMBRE_ELEMENTO];
		
		
		
		
		wxBoxSizer*	contenedorCentral;
			
			wxBoxSizer*	contenedorReposo;
			wxBoxSizer* contenedorActivacion;
				
		
		wxStaticText* lblConexionReposo;
		wxStaticText* lblConexionActiva;
		wxStaticText* lblVoltajeReposo;
		wxStaticText* lblVoltajeActivacion;
		
		
		wxChoice*	chcConexionReposo;
		wxChoice*	chcConexionActivacion;
		
		wxSpinCtrl*	spnVReposo;
		wxSpinCtrl* spnVActivacion;
		
		
	
		
};

#endif
