#include "dialogorele.h"


#include "constantes.h"

IMPLEMENT_CLASS (DialogoRele, Dialogo)
DialogoRele::DialogoRele()
{
	Init();
}

DialogoRele::DialogoRele ( 	wxWindow* ventanaPadre, wxWindowID id,
							const wxString& titulo,
							const wxPoint&  posicion,
							const wxSize&   tam,
							long  			estilo ) 
{
		Init();
		Dialogo::Create (ventanaPadre, id, titulo, posicion, tam, estilo);
}

		
void DialogoRele::Init()
{
	/*	Aqui se inicializan las variables */
}


void DialogoRele::ConstruirControles()
{
	
  
  contenedorCentral = new wxBoxSizer(wxVERTICAL);
  
  contenedorReposo = new wxBoxSizer(wxHORIZONTAL);
  lblVoltajeEntrada = new wxStaticText(this, ID_STATIC, wxT("Con voltaje de entrada"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorReposo->Add(lblVoltajeEntrada, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnVReposo = new wxSpinCtrl(this, ID_VOLTAJE_REPOSO_RELE, wxT("0"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, -10, 10, 0);
       
  contenedorReposo->Add(spnVReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  lblZumbidoReposo = new wxStaticText(this, ID_STATIC, wxT("el rel est"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorReposo->Add(lblZumbidoReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  {
  wxString __choices[] = { wxT("activado"), wxT("desactivado") };
  int __nchoices = sizeof(__choices) / sizeof(wxString);
  chcConexionReposo = new wxChoice(this, ID_CONEXION_REPOSO_RELE, wxDefaultPosition, wxDefaultSize, __nchoices, __choices, 0);
  }
  chcConexionReposo->SetSelection(1);
         
  contenedorReposo->Add(chcConexionReposo, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  contenedorCentral->Add(contenedorReposo, 1, wxEXPAND, 5);
  
  contenedorActivacion = new wxBoxSizer(wxHORIZONTAL);
  lblVoltajeActivacion = new wxStaticText(this, ID_STATIC, wxT("Con voltaje de entrada"), wxDefaultPosition, wxDefaultSize, 0);
       
  contenedorActivacion->Add(lblVoltajeActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  spnVActivacion = new wxSpinCtrl(this, ID_VOLTAJE_ACTIVACION_RELE, wxT("5"), wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, -10, 10, 0);
       
  contenedorActivacion->Add(spnVActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  lblZumbidoActivacion = new wxStaticText(this, ID_STATIC, wxT("el rel est"), wxDefaultPosition, wxSize(-1,-1), 0);
       
  contenedorActivacion->Add(lblZumbidoActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  {
  wxString __choices[] = { wxT("activado"), wxT("desactivado") };
  int __nchoices = sizeof(__choices) / sizeof(wxString);
  chcConexionActivacion = new wxChoice(this, ID_CONEXION_ACTIVACION_RELE, wxDefaultPosition, wxDefaultSize, __nchoices, __choices, 0);
  }
  chcConexionActivacion->SetSelection(0);
       
  contenedorActivacion->Add(chcConexionActivacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
  contenedorCentral->Add(contenedorActivacion, 1, wxEXPAND, 5);
  	  
  ConstruirCuadroDeDialogo (contenedorCentral);     
}

/*************************************************/
/* Implementacion de los metodos getter y setter */
/*************************************************/

void DialogoRele::getPropiedades ( Elemento* elemento )
{
	Rele*  rele= (Rele*) elemento;
	
	TransferirDeNombreDeElementoAControl (elemento);
	
	TransferirDeVoltajeASpin ( spnVReposo, 		rele->getVoltajeReposo() );
	TransferirDeVoltajeASpin ( spnVActivacion, 	rele->getVoltajeActivacion() );
	
	TransferirDeConexionAChoice ( chcConexionReposo, 	rele->getConexionReposo() );
	TransferirDeConexionAChoice ( chcConexionActivacion,rele->getConexionActivacion() );
}

void DialogoRele::setPropiedades ( Elemento* elemento )
{
	Rele*  rele= (Rele*) elemento;
	
	TransferirDeControlANombreDeElemento (elemento);
	
	TransferirDeSpinAVoltaje ( spnVReposo, 		rele->getVoltajeReposo() );
	TransferirDeSpinAVoltaje ( spnVActivacion, 	rele->getVoltajeActivacion() );
	
	TransferirDeChoiceAConexion ( chcConexionReposo, 	rele->getConexionReposo() );
	TransferirDeChoiceAConexion ( chcConexionActivacion,rele->getConexionActivacion() );

	
}		
/*************************************************/
/*	Fin de implementacion de los getter y setter */		
/*************************************************/

/*************************************************/
/*	Gestion de eventos							 */
/*************************************************/

void DialogoRele::OnCReposoActualizado ( wxCommandEvent& evento )
{

	wxChoice* cActivacion = chcConexionActivacion;
	wxChoice* cReposo = chcConexionReposo;

	wxString cadena = cReposo->GetStringSelection();
	int codigo = cadena.Cmp ("activado");
	if ( codigo==0)
	{
		//wxLogMessage ("Activado!");
		cActivacion->SetSelection (1);
	}
	else 
	{
		//wxLogMessage ("Desactivado!");
		cActivacion->SetSelection (0);
	}
}

void DialogoRele::OnCActivacionActualizado ( wxCommandEvent& evento )
{
	wxChoice* cActivacion = chcConexionActivacion;
	wxChoice* cReposo = chcConexionReposo;

	wxString cadena = cActivacion->GetStringSelection();
	int codigo = cadena.Cmp ("activado");
	if ( codigo==0 )
	{
		//wxLogMessage ("Activado!");
		cReposo->SetSelection (1);
	}
	else 
	{
		//wxLogMessage ("Desactivado!");
		cReposo->SetSelection (0);
	}
}

BEGIN_EVENT_TABLE(DialogoRele, wxDialog)

	EVT_CHOICE	 ( ID_CONEXION_REPOSO_RELE, DialogoRele::OnCReposoActualizado )
	EVT_CHOICE	 ( ID_CONEXION_ACTIVACION_RELE, DialogoRele::OnCActivacionActualizado )
END_EVENT_TABLE()
