#include "dialogotemporizador.h"
#include "dialogo.h"
#include "temporizador.h"
#include "constantes.h"

IMPLEMENT_CLASS (DialogoTemporizador, Dialogo)
DialogoTemporizador::DialogoTemporizador()
{
	Init();
}

DialogoTemporizador::DialogoTemporizador ( 	wxWindow* ventanaPadre, wxWindowID id,
							const wxString& titulo,
							const wxPoint&  posicion,
							const wxSize&   tam,
							long  			estilo ) 
{
		Init();
		Dialogo::Create (ventanaPadre, id, titulo, posicion, tam, estilo);
		vEntradaInicial		=new Voltaje(0.0);
		vSalidaInicial		=new Voltaje(0.0);
		vEntradaActivacion	=new Voltaje(0.0);
		vSalidaActivacion	=new Voltaje(0.0);
}

		
void DialogoTemporizador::Init()
{
	/*	Aqui se inicializan las variables */
}


void DialogoTemporizador::ConstruirControles()
{
	/*	Se crean los contenedores */
	contenedorCentral	=	new wxBoxSizer	(wxVERTICAL);
	
    
    /*	Ahora se van construyendo los controles y aadiendo a sus
    	correspondientes contenedores de arriba a abajo*/	
	contenedorReposo		=	new wxBoxSizer	 (wxHORIZONTAL);
	contenedorActivacion	=	new wxBoxSizer	 (wxHORIZONTAL);
	contenedorTiempo		=	new wxBoxSizer	 (wxHORIZONTAL);
	
	
	
	/* Se construye la fila para cuando el temporizador est en reposo*/
	
	lblVoltajeEntradaReposo = 	new wxStaticText (this, wxID_STATIC, 
		wxT("Cuando el temporizador recibe "),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorReposo->Add (lblVoltajeEntradaReposo,
		wxSizerFlags(PROPORCION_ETIQUETAS).Left().Center().Border (wxALL, 5) );
	
	wxString voltajeEnReposoPorDefecto="0";
	spnVEntradaReposo = new wxSpinCtrl (
		this, ID_VOLTAJE_ENTRADA_REPOSO_TEMPORIZADOR, 
		voltajeEnReposoPorDefecto, wxDefaultPosition, wxSize(ANCHURA_SPINS,ALTURA_SPINS),
		wxSP_ARROW_KEYS, VOLTAJE_MINIMO, VOLTAJE_MAXIMO, VOLTAJE_EN_REPOSO);	
	contenedorReposo->Add (spnVEntradaReposo,
		wxSizerFlags(PROPORCION_SPINS).Left().Center().Border (wxALL, 5) );
		
		
	lblVoltajeSalidaReposo = new wxStaticText (this, wxID_STATIC, 
		wxT(" el temporizador devuelve"),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorReposo->Add (lblVoltajeSalidaReposo,
		wxSizerFlags(PROPORCION_ETIQUETAS).Left().Center().Border (wxALL, 5) );
	
	spnVSalidaReposo = new wxSpinCtrl (
		this, ID_VOLTAJE_SALIDA_REPOSO_TEMPORIZADOR, 
		voltajeEnReposoPorDefecto, wxDefaultPosition, wxSize(ANCHURA_SPINS,ALTURA_SPINS),
		wxSP_ARROW_KEYS, VOLTAJE_MINIMO, VOLTAJE_MAXIMO, VOLTAJE_EN_REPOSO);	
	contenedorReposo->Add (spnVSalidaReposo,
		wxSizerFlags(PROPORCION_SPINS).Left().Center().Border (wxALL, 5) );
	
	
	/*	Fin de fila*/	
		
	/* Se crea ahora la fila con los controles para el voltaje de activacion*/
	lblVoltajeEntradaActivacion = 	new wxStaticText (this, wxID_STATIC, 
		wxT("Cuando el temporizador recibe "),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorActivacion->Add (lblVoltajeEntradaActivacion,
		wxSizerFlags(PROPORCION_ETIQUETAS).Left().Center().Border (wxALL, 5) );
	
	wxString voltajeEnActivacionPorDefecto="5";
	spnVEntradaActivacion = new wxSpinCtrl (
		this, ID_VOLTAJE_ENTRADA_REPOSO_TEMPORIZADOR, 
		voltajeEnActivacionPorDefecto, wxDefaultPosition, wxSize(ANCHURA_SPINS,ALTURA_SPINS),
		wxSP_ARROW_KEYS, VOLTAJE_MINIMO, VOLTAJE_MAXIMO, VOLTAJE_EN_REPOSO);	
	contenedorActivacion->Add (spnVEntradaActivacion,
		wxSizerFlags(PROPORCION_SPINS).Left().Border (wxALL, 5) );
	
	
	lblVoltajeSalidaReposo = new wxStaticText (this, wxID_STATIC, 
		wxT(" el temporizador devuelve"),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorActivacion->Add (lblVoltajeSalidaReposo,
		wxSizerFlags(PROPORCION_ETIQUETAS).Left().Center().Border (wxALL, 5) );
	
	spnVSalidaActivacion = new wxSpinCtrl (
		this, ID_VOLTAJE_SALIDA_TIMEOUT_TEMPORIZADOR, 
		voltajeEnActivacionPorDefecto, wxDefaultPosition, 
		wxSize(ANCHURA_SPINS,ALTURA_SPINS),
		wxSP_ARROW_KEYS, VOLTAJE_MINIMO, VOLTAJE_MAXIMO, VOLTAJE_EN_REPOSO);	
	contenedorActivacion->Add (spnVSalidaActivacion,
		wxSizerFlags(PROPORCION_SPINS).Left().Border (wxALL, 5) );
		
	/* 	Los controles de la ultima fila (los relativos al tiempo) usan proporcion
		1 para no estropear el aspecto global*/
	lblTiempo = new wxStaticText (this, wxID_STATIC, 
		wxT("Tiempo necesario:"),
		wxDefaultPosition, wxDefaultSize, ESTILO);
	contenedorTiempo->Add (lblTiempo,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) ); 	
	


	wxString timeoutPorDefecto="10";
	spnTimeout = new wxSpinCtrl (
		this, ID_SEGUNDOS_TEMPORIZADOR, 
		timeoutPorDefecto, wxDefaultPosition, wxSize(120,25),
		wxSP_ARROW_KEYS, TIMEOUT_MINIMO, TIMEOUT_MAXIMO, TIMEOUT_MINIMO);	
	contenedorTiempo->Add (spnTimeout,
		wxSizerFlags(1).Left().Center().Border (wxALL, 5) );
	/* 	Se aade un espacio ensanchable por la derecha de este contenedor para que
		no se deforme mucho el aspecto general deseado*/
	contenedorTiempo->AddStretchSpacer(1);
	
	contenedorCentral->Add (contenedorReposo,
		wxSizerFlags(1).Left().Border (wxALL, 5) );
	contenedorCentral->Add (contenedorActivacion,
		wxSizerFlags(1).Left().Border (wxALL, 5) );
	contenedorCentral->Add (contenedorTiempo,
		wxSizerFlags(1).Left().Border (wxALL, 5) );
	
	/*Fin de la fila central*/
	
	/*	Ahora que ya se tienen los controles centrales, se incrustan
		en el cuadro de dialogo basico estandar */
	
	ConstruirCuadroDeDialogo (contenedorCentral);     
}

/*************************************************/
/* Implementacion de los metodos getter y setter */
/*************************************************/

void DialogoTemporizador::getPropiedades ( Elemento* elemento )
{
	Temporizador* elementoConcreto = (Temporizador*) elemento;
	
	TransferirDeNombreDeElementoAControl (elemento);
	
	spnVEntradaReposo->SetValue 	( 
		(int)	elementoConcreto->getVoltajeEntradaInicial()->getValor() 	);
	spnVSalidaReposo->SetValue 		( 
		(int) elementoConcreto->getVoltajeSalidaInicial()->getValor()		);
	spnVEntradaActivacion->SetValue ( 
		(int)  elementoConcreto->getVoltajeActivacion()->getValor() 		);
	spnVSalidaActivacion->SetValue	(  
		(int) elementoConcreto->getVoltajeSalidaEnTimeout()->getValor()	);
		
	spnTimeout->SetValue 			( elementoConcreto->getTiempoMax()					);
		
}

void DialogoTemporizador::setPropiedades ( Elemento* elemento )
{
	Temporizador *tempo = (Temporizador*) elemento;
	
	TransferirDeControlANombreDeElemento (tempo);
	TransferirDeSpinAVoltaje ( spnVEntradaReposo, 
								tempo->getVoltajeEntradaInicial() 	);
	TransferirDeSpinAVoltaje ( spnVSalidaReposo, 
								tempo->getVoltajeSalidaInicial() 	);
	TransferirDeSpinAVoltaje ( spnVSalidaActivacion, 
								tempo->getVoltajeActivacion()		);
	TransferirDeSpinAVoltaje ( spnVEntradaActivacion,
								tempo->getVoltajeSalidaEnTimeout()	);
	
	tempo->setTiempoMax		 ( spnTimeout->GetValue() 				);
}		
/*************************************************/
/*	Fin de implementacion de los getter y setter */		
/*************************************************/


/************************Implementacion de gestion de eventos *************/

void DialogoTemporizador::OnCReposoActualizado ( wxCommandEvent& evento )
{
	wxString cadena = chcMagnetismoReposo->GetStringSelection();
	int codigo = cadena.Cmp ("activado");
	if ( codigo==0)
	{
		//wxLogMessage ("Activado!");
		chcMagnetismoActivacion->SetSelection (1);
	}
	else 
	{
		//wxLogMessage ("Desactivado!");
		chcMagnetismoActivacion->SetSelection (0);
	}
}

void DialogoTemporizador::OnCActivacionActualizado ( wxCommandEvent& evento )
{

	wxString cadena = chcMagnetismoActivacion->GetStringSelection();
	int codigo = cadena.Cmp ("activado");
	if ( codigo==0)
	{
		//wxLogMessage ("Activado!");
		chcMagnetismoReposo->SetSelection (1);
	}
	else 
	{
		//wxLogMessage ("Desactivado!");
		chcMagnetismoReposo->SetSelection (0);
	}
}

BEGIN_EVENT_TABLE(DialogoTemporizador, wxDialog)
	//EVT_UPDATE_UI( ID_MAGNETISMO_REPOSO, DialogoTemporizador::OnCReposoActualizado )
	//EVT_UPDATE_UI( ID_MAGNETISMO_ACTIVACION, DialogoTemporizador::OnCActivacionActualizado )
	//EVT_CHOICE	 ( ID_MAGNETISMO_REPOSO_ELECTROIMAN, DialogoTemporizador::OnCReposoActualizado )
//	EVT_CHOICE	 ( ID_MAGNETISMO_ACTIVACION_ELECTROIMAN, DialogoTemporizador::OnCActivacionActualizado )
END_EVENT_TABLE()
