/*	Fichero dialogopulsador.h
	
	Contiene el interfaz para el cuadro de dialogo que permite configurar
	un pulsador	
	
	Ultima actualizacion: Viernes 6-10-2006
*/


#ifndef _dialogotemporizador_h
#define _dialogotemporizador_h

#include "wx/wx.h"
#include "wx/statline.h"
#include "wx/spinctrl.h"
#include "wx/valgen.h"
/*	Este fichero es necesario para que el cuadro de dialogo pueda manejar
	los mismos tipos de seales que manejan los elementos */
#include "senal.h"
#include "temporizador.h"

#include "dialogo.h"


/* Identificadores numricos asignados a los botones del cuadro de dialogo*/
enum {
	ID_DIALOGO_TEMPORIZADOR=7760,
	ID_VOLTAJE_SALIDA_TIMEOUT_TEMPORIZADOR,	
	ID_VOLTAJE_SALIDA_REPOSO_TEMPORIZADOR, 
	ID_VOLTAJE_ENTRADA_REPOSO_TEMPORIZADOR, 
	ID_VOLTAJE_ENTRADA_ACTIVACION_TEMPORIZADOR, 
	ID_SEGUNDOS_TEMPORIZADOR
};

class DialogoTemporizador : public Dialogo
{
	DECLARE_CLASS (DialogoTemporizador)
	DECLARE_EVENT_TABLE()
	public: 
		DialogoTemporizador ();
		DialogoTemporizador (wxWindow* ventanaPadre, 
							wxWindowID id=ID_DIALOGO_TEMPORIZADOR,
							const wxString& titulo= wxT ("Configurar electroiman"),
							const wxPoint&  posicion=wxDefaultPosition,
							const wxSize&   tam=wxDefaultSize,
							long  			estilo=wxCAPTION | 
													wxRESIZE_BORDER |
													wxSYSTEM_MENU );

		
		void ConstruirControles();
		void Init ();

		/* Metodos getter y setter */
		
		/*	Lee el nombre y valores del elemento y los representa en
		el cuadro de dilogo */
		virtual void getPropiedades ( Elemento* elemento );
	
		/*	Hace que un elemento adquiera las propiedades del dilogo */
		virtual void setPropiedades ( Elemento* elemento );
		
		
		void 		OnCReposoActualizado ( wxCommandEvent& evento  );

		void 		OnCActivacionActualizado ( wxCommandEvent& evento  );
	private:
		
		Voltaje*	vEntradaInicial;
		Voltaje*	vSalidaInicial;
		Voltaje*	vEntradaActivacion;
		Voltaje*	vSalidaActivacion;
		/*	Los controles. */
		wxBoxSizer*	contenedorCentral;
			
			wxBoxSizer*	contenedorReposo;
			wxBoxSizer* contenedorActivacion;
			wxBoxSizer*	contenedorTiempo;
				
		wxStaticText* lblVoltajeEntradaReposo;
		wxStaticText* lblVoltajeEntradaActivacion;
		wxStaticText* lblVoltajeSalidaReposo;
		wxStaticText* lblVoltajeSalidaTimeout;
		wxStaticText* lblTiempo;
		wxStaticText* lblSegundos;
		
		wxChoice*	chcMagnetismoReposo;
		wxChoice*	chcMagnetismoActivacion;
		
		wxSpinCtrl*	spnVEntradaReposo;
		wxSpinCtrl*	spnVSalidaReposo;
		wxSpinCtrl* spnVEntradaActivacion;
		wxSpinCtrl* spnVSalidaActivacion;
		wxSpinCtrl* spnTimeout;
		
		#define ANCHURA_SPINS			15
		#define ALTURA_SPINS			-1
		#define PROPORCION_ETIQUETAS 	3
		#define PROPORCION_SPINS		1
		
};

#endif
