#include "motorvisual.h"

MotorVisual::MotorVisual()
{	
	/*	El bitmap ya ha sido
		creado en el constructor de la clase padre ElementoVisual,
		por lo que aqui podemos cargarlo sin preocuparnos de reservar */
		
		wxString ficheroIcono ("iconos/Motor.xpm");
		bitmapEnPantalla.LoadFile (ficheroIcono, TIPO_ICONOS);
		
		Voltaje* voltajeReposo		=	new Voltaje (0.0);
		Voltaje* voltajeGiroCW		=	new	Voltaje (5.0);
		Voltaje* voltajeGiroCCW	=	new Voltaje (-5.0);

		Giro* giroReposo	=	new Giro ("stop");
		Giro* giroCW		= 	new Giro ("cw");
		Giro* giroCCW		=	new Giro ("ccw");
		
		unsigned int rpm=1200;
		elementoEnvuelto = new Motor( voltajeReposo, giroReposo,
			voltajeGiroCW, giroCW, voltajeGiroCCW, giroCCW, rpm);
		SetNombre ("Motor");
}
void MotorVisual::setElementoEnvuelto (Elemento* elementoPasado)
{
	wxLogMessage ("---MotorVisual::setElementoEnvuelto---");
	ElementoVisual::setElementoEnvuelto (elementoPasado);
	Motor *motor			= dynamic_cast<Motor*> (elementoPasado);
	this->elementoEnvuelto	= motor;
	senalReposo	=motor->getVoltajeReposo();
	senalActivacion = motor->getVoltajeGiroCW();
	
	/* Aqui no hay seales de reposo ni activacion */
}
Dialogo* MotorVisual::FabricarDialogo()
{
	wxMessageBox ("Obteniendo dialogo motor");
	return new DialogoMotor();
}

void MotorVisual::ManejarEntrada (Senal* s, int posicion)
{
	wxLogMessage ("Se ha modificado la entrada del motor");
}

