#include "sistemavisual.h"

SistemaVisual::SistemaVisual()
{	
	wxLogMessage ("---SistemaVisual::SistemaVisual---");
	/*	Se crea el icono */
	#include "../iconos/SistemaIcono.xpm"
	bitmapEnPantalla = wxBitmap (SistemaIcono);
	SetNombre ("Sistema");
	elementoEnvuelto=new Sistema();

}
SistemaVisual::~SistemaVisual()
{
	wxLogMessage ("Destruyendo sistema visual");
	delete paginaPadre;
}

void SistemaVisual::setElementoEnvuelto (Elemento* elementoPasado)
{
	wxLogMessage ("---SistemaVisual::setElementoEnvuelto---");
	ElementoVisual::setElementoEnvuelto (elementoPasado);
	Sistema* sistema 	= dynamic_cast<Sistema*> (elementoPasado);
	this->elementoEnvuelto	= sistema;
	
	/* Aqui no hay seales de reposo ni activacion */
}

Dialogo* SistemaVisual::FabricarDialogo()
{
	return new DialogoSistema();
}

void SistemaVisual::manejarEntrada (Senal* s, int posicion)
{
	wxLogMessage ("Se ha modificado la entrada del sistema");
}

int	SistemaVisual::ElegirSalidaDeEmisor()
{
	/* Esta es la salida por defecto */
	DialogoEleccion d(NULL);
	map <string, int> salidas;
	
//	Sistema* sistema 	= dynamic_cast<Sistema*> (elementoEnvuelto);
	salidas = this->getNombreSalidas();
	
	/*	Esto permite evitar que se muestre un dilogo vacio*/
	int totalSalidas = salidas.size();
	if (totalSalidas == 0 ) {
		return ELECCION_CANCELADA;
		wxMessageBox (nombreDelElementoVisual+" est vaco");
	}
	
	d.CargarDatos (salidas);
	d.SetTipoDeDialogo (DIALOGO_SALIDAS);
	d.SetNombre (wxString(nombreDelElementoVisual));
	if (d.ShowModal() == ID_OK)
	{
		wxString eleccion	 	= d.GetSenalElegida();
		const char* intermedia 	= eleccion.c_str();
		string salidaElegida (intermedia);
//		wxLogMessage ("Se eligio %s, %i", salidaElegida.c_str(), salidas[salidaElegida]);
		return salidas[salidaElegida];
	}
	else {
		return ELECCION_CANCELADA;
	}	
}

int	SistemaVisual::ElegirEntradaDeReceptor()
{
	DialogoEleccion d(NULL);
	map <string, int> entradas;
	//Sistema* sistema 	= dynamic_cast<Sistema*> (elementoEnvuelto);
	entradas = this->getNombreEntradas();
	/*	Esto permite evitar que se muestre un dilogo vacio*/
	int totalEntradas = entradas.size();
	if (totalEntradas == 0 ) {
		wxMessageBox (nombreDelElementoVisual+" est vaco");
		return ELECCION_CANCELADA;
	}
	
	d.CargarDatos (entradas);
	d.SetNombre (wxString(nombreDelElementoVisual));
	d.SetTipoDeDialogo (DIALOGO_ENTRADAS);
	
	if (d.ShowModal() == ID_OK)
	{
		wxString eleccion	 	= d.GetSenalElegida();
		const char* intermedia 	= eleccion.c_str();
		string entradaElegida (intermedia);
//		wxLogMessage ("Se eligio %s, %i", entradaElegida.c_str(), entradas[entradaElegida]);
		return entradas[entradaElegida];
	}
	else {
		return ELECCION_CANCELADA;
	}
}

map<string,int> SistemaVisual::getNombreEntradas	()
{
	wxLogMessage ("---SistemaVisual::getNombreEntradas()---");
	Sistema* sistema 	= dynamic_cast<Sistema*> (elementoEnvuelto);
	return sistema->getNombreEntradas();
}

map<string,int> SistemaVisual::getNombreSalidas	()
{
	wxLogMessage ("---SistemaVisual::getNombreEntradas()---");
	Sistema* sistema 	= dynamic_cast<Sistema*> (elementoEnvuelto);
	return sistema->getNombreSalidas();
}

Sistema* SistemaVisual::getRefSistema()
{
	Sistema* sistema 	= dynamic_cast<Sistema*> (elementoEnvuelto);
	return sistema;
}
