#include "ventana.h"
//#include "wx/debug.h"

#include "dialogos/dialogopulsador.h"
#include "dialogos/dialogoelectroiman.h"
#include "dialogos/dialogotemporizador.h"
#include "dialogos/dialogofotosensor.h"
#include "dialogos/dialogocontador.h"
#include "dialogos/dialogomotor.h"
#include "dialogos/dialogoreed.h"
#include "dialogos/dialogobiestable.h"
#include "dialogos/dialogozumbador.h"
#include "dialogos/dialogorele.h"
#include "dialogos/dialogolampara.h"
#define ID_LIBRO 7900

#include "wx/image.h"
#include "wx/sysopt.h"
#include "wx/filename.h"
#include "wx/wfstream.h"
#include "wx/log.h"

Ventana::Ventana() : wxFrame (NULL, wxID_ANY, "SimPROC")
{	
	/*	Al comienzo no hay ningun sistema activo */
	sistemaActivo= NULL;
	
	subsistemas=1;
	/* Al comienzo la barra de herramientas no esta activa */
	barraDeHerramientasEstaActiva=false;
	
	/*	Al final del constructor lo primero que se hace es llamar
		a ConmutarVectorizacion, que deshabilita todo y pone esto
		a false. Es un truco para no tener que escribir Disable
		al principio */
	vectoresHabilitados = true;
		
	/*	Ningun nombre de archivo*/
	nombreArchivo="";
		
	/*	Al principio el libro no contiene nada*/
	paginaActual=0;
	totalPaginas=1;
	
	/*	Esta posicion es mas o menos el centro del panel.
		Aqui se insertarn por defecto todos los elementos */
	pos_insercion_por_defecto = wxPoint (350,300);
		
	/* Se crean los mens...*/	
	barraMenu=this->crearMenus();
	SetMenuBar (barraMenu);
	
	/*	Se crea el libro que contiene los subsistemas */
	libro	=	new wxNotebook(this, ID_LIBRO, wxDefaultPosition, wxDefaultSize,
		wxNB_TOP);
	
	
	/*	El panel contiene los controles que aparecen a la izquierda
		de la ventana. El panel contendr los elementos del sistema	*/
//	PanelElementos* botonera	=new PanelElementos(this, wxVERTICAL);
	botonera	=new PanelElementos(this, wxVERTICAL);
	botonera->Habilitar();	
	/*	Con esto se crean unos controles que permiten crear vectores */
	wxStaticBoxSizer *szrCreacionVectores;
  	szrCreacionVectores = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("Vector")), wxHORIZONTAL);
  	chkVector = new wxCheckBox(this, ID_CREAR_VECTOR, wxT("Crear vector"), wxDefaultPosition, wxDefaultSize, 0);
	szrCreacionVectores->Add(chkVector, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	
	lblNumElementos = new wxStaticText(this, ID_DEFAULT, wxT("Elementos:"), wxDefaultPosition, wxDefaultSize, 0);
	szrCreacionVectores->Add(lblNumElementos, 0, wxALL|wxALIGN_CENTER_VERTICAL,5);
	
	spnNumElementos = new wxSpinCtrl(this, ID_NUMELEMENTOS, wxT("2"), 
		wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, 
		2, 10, 2);
	szrCreacionVectores->Add(spnNumElementos, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	
	cmbPosicion = new wxComboBox(this, ID_COMBO_POSICION, wxT("En horizontal"), wxDefaultPosition, wxSize(80,-1), 0, NULL, wxCB_READONLY);
	cmbPosicion->Append(wxT("En horizontal"));
	cmbPosicion->Append(wxT("En vertical"));
	cmbPosicion->SetValue(wxT("En vertical"));
	
	szrCreacionVectores->Add(cmbPosicion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	lblSeparacion = new wxStaticText(this, ID_DEFAULT, wxT("con separacin (pixeles)"), wxDefaultPosition, wxDefaultSize, 0);
	szrCreacionVectores->Add(lblSeparacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	
	/*	La separacion entre iconos es al menos el tamao de la 
		anchura de iconos, con un margen de 20 pixeles mas */
	spnSeparacion = new wxSpinCtrl(this, ID_SEPARACION_VECTORES, wxT("1"), 
		wxDefaultPosition, wxSize(45,-1), wxSP_ARROW_KEYS, 
		1, 20, 1);
	szrCreacionVectores->Add(spnSeparacion, 0, wxALL|wxALIGN_CENTER_VERTICAL, 5);
	
	/*	Fin de controles para crear vectores */
	
	/*	El control texto es un cuadro de texto que muestra los eventos
		y mensajes de importancia que se vayan produciendo */
	texto =new wxTextCtrl 
			(this, wxID_ANY, _T("Registro de eventos.\n"),
             wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE) ;

	

	/*	El contenedor de arriba contiene la botonera y el panel.
		El contenedor principal va a contener dicho contenedorArriba (con
		la botonera y el panel) y abajo el control "texto"*/
	contenedorArriba	=	new wxBoxSizer (wxHORIZONTAL);
	contenedorPrincipal	=	new wxBoxSizer (wxVERTICAL);
	
	contenedorArriba->Add (botonera->getContenedor(), 0);
	contenedorArriba->Add (libro,4, wxGROW, 5);

	
	texto->AppendText ("Eventos:\n");
	contenedorPrincipal->Add (contenedorArriba,6, wxEXPAND);
	contenedorPrincipal->Add (szrCreacionVectores, 1, wxEXPAND);
	contenedorPrincipal->Add (texto,1, wxEXPAND);
	
	/* Las acciones de los registradores de log se pueden manipular
		con esta constante por si queremos enviar la salida a
		pantalla o a pantalla+fichero*/
	
	#define REGISTRAR_ACCIONES_EN_PANTALLA
	
	#ifdef REGISTRAR_ACCIONES_EN_PANTALLA
		/* Instalamos un registrador que envia la salida de los
			log hacia la pantalla*/
		wxLogTextCtrl *registrador = new wxLogTextCtrl ( texto );
		delete wxLog::SetActiveTarget (registrador);
	#endif

		/* Y ese registrador va a ir encadenado a otro registrador
			que envia la salida al fichero*/
			
		
		/* El puntero a ese fichero se va a usar para poder
			enviarle los log*/
		FILE* puntero = fopen("SimProc.log", "w");
		
		/* Se crea el registrador...*/
		wxLogStderr* registrador_en_fichero=new wxLogStderr(puntero);
		wxLogChain* cadena = new wxLogChain (registrador_en_fichero);
		/*... y se marca como activo. Aunque normalmente se trabaja
			borrando el que nos devuelve (que era el registrador 
			por defecto antiguo) aqui no se hace porque sino nos
			cargariamos la cadena de registradores. El borrado
			o no dependera de si se ha solicitado enviar la
			salida a pantalla*/
		#ifdef REGISTRAR_ACCIONES_EN_PANTALLA
			wxLog::SetActiveTarget (cadena);
		#else
			/* Si no esta definido entonces s podemos borrar
				el logger anterior por defecto*/
			delete wxLog::SetActiveTarget (cadena);
		#endif
		//wxMessageBox ("Se estan registrando las acciones en el fichero SimProc.log
//		\nPor favor, en caso de error enviar el fichero para ayudar en la depuracion");
			
		wxLogMessage ("+--------------------------+");
		wxLogMessage ("| Comienzo de la ejecucin |");
		wxLogMessage ("+--------------------------+");
		/* Con esto se evita que aparezca la hora en todos los log*/
		wxLog::SetTimestamp(NULL);
	this->SetBackgroundColour (wxColour(128,128,128));
	this->SetMinSize (wxSize(450, 350));
	this->SetSizer (contenedorPrincipal);
	contenedorPrincipal->Fit (this);
	contenedorPrincipal->SetSizeHints(this);
	ConmutarVectorizacion();
}

Ventana::~Ventana()
{
	wxLog::FlushActive();
}

wxMenuBar* Ventana::crearMenus()
{
	/*	Se crea la barra de menus*/
	barraMenu	=	new wxMenuBar();
	
	
	/*	Se crea el menu archivo...*/
	menuArchivo	=	new wxMenu();
	
	/*	...que contiene las opciones Nuevo, Abrir, 
		Guardar, Guardar como y Salir */
	menuArchivo->Append ( MENU_ARCHIVO_NUEVO, "&Nuevo");
	menuArchivo->AppendSeparator();
	menuArchivo->Append ( MENU_ARCHIVO_ABRIR, "&Abrir");
	menuArchivo->Append ( MENU_ARCHIVO_GUARDAR, "&Guardar");
	menuArchivo->Append ( MENU_ARCHIVO_GUARDAR_COMO
						, "G&uardar como");
	menuArchivo->AppendSeparator();
	menuArchivo->Append ( MENU_ARCHIVO_SALIR, "&Salir");
	
	/*	El menu Edicion... */
	menuEdicion	=	new wxMenu();
	menuEdicion->Append ( MENU_EDICION_CORTAR, "&Cortar");
	menuEdicion->Append ( MENU_EDICION_COPIAR, "Copiar");
	menuEdicion->Append ( MENU_EDICION_PEGAR, "Pegar");
	menuEdicion->Append ( MENU_EDICION_ELIMINAR_ELEMENTO, "Eliminar elemento");
	menuEdicion->Append ( MENU_EDICION_ELIMINAR_SISTEMA, "Eliminar sistema");
	/*	El men ver */
	menuVer		= 	new wxMenu();
	menuVer->Append	(MENU_VER_XML, "Ver en formato XML");
	
	menuModo	=	new wxMenu();
	menuModo->AppendRadioItem (MENU_MODO_CONSTRUCCION, "Modo construccin");
	menuModo->AppendRadioItem (MENU_MODO_SIMULACION, "Modo simulacin");
	
	/*	El menu Insertar */
	menuInsertar =	new wxMenu();
	menuInsertar->Append (MENU_INSERTAR_SISTEMA, "Sistema");	
	menuInsertar->Append (MENU_INSERTAR_SISTEMA_DE_PRUEBA, "Test elemental");	
	menuInsertar->Append (MENU_INSERTAR_SISTEMA_DE_PRUEBA2, "Test temporizador");	
	menuInsertar->Append (MENU_INSERTAR_SISTEMA_DE_PRUEBA3, "Test semaforo");	
	
	menuAyuda	=	new wxMenu();
	menuAyuda->Append ( MENU_AYUDA_ACERCA_DE, "Acerca de");
	
	/*	Y una vez creadas las opciones del menu
		se aaden todas a la barra de menus */
	barraMenu->Append ( menuArchivo, 	"Archivo" 		);
	barraMenu->Append ( menuEdicion, 	"Edicion" 		);
	barraMenu->Append ( menuVer, 		"Ver"		 	);
	barraMenu->Append ( menuModo, 		"Modo"		 	);
	barraMenu->Append ( menuInsertar, 	"Insertar" 		);
	barraMenu->Append ( menuAyuda, 		"Ayuda"			);
	return barraMenu;
}

void Ventana::ConmutarVectorizacion()
{
	if (vectoresHabilitados)
	{
		cmbPosicion->Disable();
		lblSeparacion->Disable();
		lblNumElementos->Disable();
		spnSeparacion->Disable();
		spnNumElementos->Disable();
		vectoresHabilitados=false;
	}
	else {
		cmbPosicion->Enable();
		lblSeparacion->Enable();
		lblNumElementos->Enable();
		spnSeparacion->Enable();
		spnNumElementos->Enable();
		vectoresHabilitados=true;
	}
}


void Ventana::CrearPaginaSubsistema(SistemaVisual *s)
{
	wxLogMessage ("---Ventana::CrearPaginaSubsistema---");
	/*	Se crea una nueva pgina */
	Pagina* p=new Pagina(libro);
	libro->AddPage(p, s->GetNombre(), false);
	/* 	Dentro del sistema visual est el sistema que contiene los
		elementos. Esta pgina va a mostrar los elementos que
		se aadan en este sistema. Aqui yace la conexion entre el 
		sistema visual que se inserta en una pgina y los elementos
		que se aaden en otra pgina distinta*/
	Sistema* sistema = s->getRefSistema();
	/* 	Esta nueva pagina va "conectada" al sistema visual que
		se ha creado antes y que nos han pasado como parmetro */
	p->SetSistema(sistema);
	subsistemas++;
}

void Ventana::OnPulsadorActivo	(wxCommandEvent& evento)
{
	barraDeHerramientasEstaActiva	=	true;
	elementoActivo					=	PULSADOR;
	ReiniciarEstadoPaginaActual();
}
void Ventana::OnReleActivo	(wxCommandEvent& evento)
{
	barraDeHerramientasEstaActiva	=	true;
	elementoActivo					=	RELE;
	ReiniciarEstadoPaginaActual();
}

void Ventana::OnBiestableActivo	(wxCommandEvent& evento)
{
	barraDeHerramientasEstaActiva	=	true;
	elementoActivo					=	BIESTABLE;
	ReiniciarEstadoPaginaActual();
}

void Ventana::OnReedActivo	(wxCommandEvent& evento)
{
	barraDeHerramientasEstaActiva	=	true;
	elementoActivo					=	REED;
	ReiniciarEstadoPaginaActual();
}

void Ventana::OnTemporizadorActivo	(wxCommandEvent& evento)
{
	barraDeHerramientasEstaActiva	=	true;
	elementoActivo					=	TEMPORIZADOR;
	ReiniciarEstadoPaginaActual();
}
void Ventana::OnContadorActivo	(wxCommandEvent& evento)
{
	barraDeHerramientasEstaActiva	=	true;
	elementoActivo					=	CONTADOR;
	ReiniciarEstadoPaginaActual();
}

void Ventana::OnElectroimanActivo	(wxCommandEvent& evento)
{
	barraDeHerramientasEstaActiva	=	true;
	elementoActivo					=	ELECTROIMAN;
	ReiniciarEstadoPaginaActual();
}

void Ventana::OnZumbadorActivo	(wxCommandEvent& evento)
{
	barraDeHerramientasEstaActiva	=	true;
	elementoActivo					=	ZUMBADOR;
	ReiniciarEstadoPaginaActual();
}

void Ventana::OnLamparaActivo	(wxCommandEvent& evento)
{
	barraDeHerramientasEstaActiva	=	true;
	elementoActivo					=	LAMPARA;
	ReiniciarEstadoPaginaActual();
}


void Ventana::OnMotorActivo		(wxCommandEvent& evento)
{
	barraDeHerramientasEstaActiva	=	true;
	elementoActivo					=	MOTOR;
	ReiniciarEstadoPaginaActual();
}

void Ventana::OnSistemaActivo	(wxCommandEvent& evento)
{
	barraDeHerramientasEstaActiva	=	true;
	elementoActivo					=	SISTEMA;
	ReiniciarEstadoPaginaActual();
}
void Ventana::OnFotosensorActivo	(wxCommandEvent& evento)
{
	barraDeHerramientasEstaActiva	=	true;
	elementoActivo					=	FOTOSENSOR;
	ReiniciarEstadoPaginaActual();
}


void Ventana::OnClickEnNotebook (wxEvtClickNotebook& evento)
{
	
	
	/* Si la barra de herramientas no estaba activa, no hay nada que hacer */
	if (!barraDeHerramientasEstaActiva) {
		return ;
	}
	
	Pagina *paginaActiva = (Pagina*) libro->GetCurrentPage();
	
	//wxMessageBox (wxT ("Click en notebook"), wxT ("lanzado"));
	
	/* 	Si alguien pulso algun elemento de la barra de herramientas...*/
	if (barraDeHerramientasEstaActiva) {	
		
		if (vectoresHabilitados) {
			int distancia		= spnSeparacion->GetValue();
			int numElementos 	= spnNumElementos->GetValue();
			int factorhorizontal, factorvertical;
			
			/*	Esto hace que se sume solo la distancia en horizontal o
				en vertical */
			if (cmbPosicion->GetStringSelection()==wxString ("En horizontal"))
			{
				factorhorizontal 	= 1;
				factorvertical		= 0;
			}
			else {
				factorhorizontal 	= 0;
				factorvertical		= 1;
			}
			
			int tipoDeElemento = elementoActivo;
			for (int i=0; i<numElementos; i++)
			{
				/*	Se crean los elementos, se aaden al vector y a la pgina*/
				int posicion_x = (factorhorizontal*(i*(distancia+ANCHURA_ICONOS)))+
								evento.getX();
				int posicion_y = (factorvertical*(i*(distancia+ALTURA_ICONOS)))+
								evento.getY() ;
				
				ElementoVisual* ev= 
					insertarObjetoEnSistema (tipoDeElemento, paginaActiva, 
						posicion_x, posicion_y );
				assert (ev!=NULL);
			}
//			wxLogMessage ("Vector aadido");
		}
		else {
			insertarObjetoEnSistema (elementoActivo, libro->GetCurrentPage(), 
				evento.getX(), evento.getY() );
		} /* Fin de if vectoresHabilitados */
		
	} /* Fin de if barra de herramientas actva */
	paginaActiva->ReiniciarEstado();
}


void Ventana::OnPagina ( wxNotebookEvent& evento	)
{
	
}
void Ventana::OnClickCrearVector ( wxCommandEvent& 		evento	)
{
	ConmutarVectorizacion();
}
void Ventana::ReiniciarEstadoPaginaActual()
{
	Pagina *p = (Pagina*) libro->GetCurrentPage();
	if (p!=NULL) 
	{
		p->ReiniciarEstado();
	}
}

/*	Procedimiento para aadir un nuevo elemento
	1.- Crear el gestor de eventos OnElemento...
	2.- Conectarlo en la tabla de eventos
	3.- Aadir el case correspondiente en la funcion insertarObjetoEnSistema
*/
void Ventana::Localizar(wxMouseEvent& evento)
{

}
BEGIN_EVENT_TABLE(Ventana, wxFrame)
	EVT_MENU (MENU_ARCHIVO_ABRIR, 				Ventana::OnMenuArchivoAbrir)
	EVT_MENU (MENU_INSERTAR_SISTEMA, 			Ventana::OnMenuInsertarSistema)
	EVT_MENU (MENU_VER_XML,		 				Ventana::OnMenuVerXML)
	EVT_MENU (MENU_INSERTAR_SISTEMA_DE_PRUEBA, 	Ventana::OnMenuInsertarSistemaDePrueba)
	EVT_MENU (MENU_INSERTAR_SISTEMA_DE_PRUEBA2,	Ventana::OnMenuInsertarSistemaDePrueba2)
	EVT_MENU (MENU_INSERTAR_SISTEMA_DE_PRUEBA3,	Ventana::OnMenuInsertarSistemaDePrueba3)
	EVT_MENU (MENU_ARCHIVO_GUARDAR, 			Ventana::OnMenuArchivoGuardar)
	EVT_MENU (MENU_ARCHIVO_GUARDAR_COMO, 		Ventana::OnMenuArchivoGuardarComo)
	EVT_MENU (MENU_AYUDA_ACERCA_DE, 			Ventana::OnMenuAyudaAcercaDe )
	EVT_MENU (MENU_EDICION_ELIMINAR_ELEMENTO,	Ventana::OnMenuEdicionEliminarElemento )
	EVT_MENU (MENU_EDICION_ELIMINAR_SISTEMA,	Ventana::OnMenuEdicionEliminarSistema )
	EVT_MENU (MENU_MODO_CONSTRUCCION, 			Ventana::OnMenuModoConstruccion )
	EVT_MENU (MENU_MODO_SIMULACION, 			Ventana::OnMenuModoSimulacion )
	/* 	Que ocurre cuando alguien pulsa el boton Pulsador de
		la barra de herramientas?. Se dispara la funcion OnPulsadorActivo*/
	EVT_BUTTON ( wxID_PULSADOR, 		Ventana::OnPulsadorActivo		)
	EVT_BUTTON ( wxID_RELE,				Ventana::OnReleActivo			)
	EVT_BUTTON ( wxID_REED,				Ventana::OnReedActivo			)
	EVT_BUTTON ( wxID_TEMPORIZADOR,		Ventana::OnTemporizadorActivo	)
	EVT_BUTTON ( wxID_BIESTABLE, 		Ventana::OnBiestableActivo		)
	EVT_BUTTON ( wxID_CONTADOR, 		Ventana::OnContadorActivo		)
	EVT_BUTTON ( wxID_ZUMBADOR, 		Ventana::OnZumbadorActivo		)
	EVT_BUTTON ( wxID_ELECTROIMAN,	 	Ventana::OnElectroimanActivo	)
	EVT_BUTTON ( wxID_LAMPARA,	 		Ventana::OnLamparaActivo		)
	EVT_BUTTON ( wxID_MOTOR,	 		Ventana::OnMotorActivo			)
	EVT_BUTTON ( wxID_FOTOSENSOR,	 	Ventana::OnFotosensorActivo		)
	EVT_BUTTON ( wxID_SISTEMA,	 		Ventana::OnSistemaActivo		)
	EVT_CHECKBOX(ID_CREAR_VECTOR,		Ventana::OnClickCrearVector		)	
	EVT_NOTEBOOK_PAGE_CHANGED(ID_LIBRO, Ventana::OnPagina				)
	
	EVT_CLICK_NOTEBOOK (wxID_ANY, 		Ventana::OnClickEnNotebook		)
	//Usado solo para depurar	
//	EVT_ENTER_WINDOW (Ventana::Localizar)	
	
	
END_EVENT_TABLE()

