#ifndef _biestable_
#define _biestable_

#include "elemento.h"
#include "xmlserializable.h"
#include "nodoxml.h"


class Biestable: public Elemento
{
	public:
		Biestable();
		Biestable(Voltaje* activar_r, Voltaje* desactivar_r,
			Voltaje* activar_s, Voltaje* desactivar_s,
			Voltaje* activar_Q, Voltaje* desactivar_Q, 
			Voltaje* activar_Qneg, Voltaje* desactivar_Qneg);
		int setEntrada(Senal* s, int posicion=POS_ENTRADA);
		int setReset (Voltaje* c);
		int setSet (Voltaje *c);
		
		//Mtodos heredados de XMLSerializable y que se deben implementar
		virtual NodoXML getXML ( DOMImplementation* impl );
		virtual void construir (DOMElement*);
		/*	Metodos getter*/
		Voltaje* 	getQ();
		Voltaje* 	getQneg();
		Voltaje* 	getActivacionR();
		Voltaje* 	getActivacionS();
		
		/*	Estos metodos se han aadido despues para que sean mas similares
			al resto de interfaces de los otros metodos pero pueden usarse
			estos y los anteriores (al gusto) */
		Voltaje*	getEntradaReposoR();
		Voltaje*	getEntradaActivacionR();
		Voltaje*	getEntradaReposoS();
		Voltaje*	getEntradaActivacionS();
		
		Voltaje*	getSalidaReposoQ();
		Voltaje*	getSalidaActivacionQ();
		Voltaje*	getSalidaReposoQneg();
		Voltaje*	getSalidaActivacionQneg();
		
	protected:
		
		Voltaje* activar_R;
		Voltaje* desactivar_R;
		
		Voltaje* activar_S;
		Voltaje* desactivar_S;
		
		Voltaje* activar_Q;
		Voltaje* desactivar_Q;
		
		Voltaje* activar_Qneg;
		Voltaje* desactivar_Qneg;
		
	private:
		int obtenerValorR(Voltaje* valor_r);
		int obtenerValorS(Voltaje* valor_s);
		
};

#endif
