#ifndef _conector_
#define _conector_

#include "constantes.h"
#include "elemento.h"
/*	Un conector es un elemento que no tiene nada de especial, se dedica
	solamente a propagar seales, de forma que la seal que recibe de
	entrada la pone en su salida*/
class Conector : public Elemento
{
	public:
		Conector();
		~Conector();
		int setEntrada (Senal *s, int posicion=POS_ENTRADA);	
		void actualizar();
		bool tienePorSuscriptor (Elemento* e);
		
		virtual void manejarEntrada (Senal* entrada, int posicion){};
		
		/*	Nos dice si esta conector est ya conectado a
			algo o por el contrario se puede usar. La clase
			sistema utiliza estos conectores para "enganchar"
			elementos del exterior a elementos "contenidos"
			dentro del sistema*/
		bool estaLibre();
		
		/*	El nombre de los conectores va a ser el nombre de
			los elementos con los cuales van conectados */
		const char* getNombreElemento();
		
		/*	Los conectores no son visibles */
		virtual bool esVisible();
		void marcarComoUsado();
 		/* En conectores que estuvieran ocupados se liberan
 			la conexion */
		void liberar();
		
		/* 	Cuando alguno de nuestros suscriptores llama
			a este mtodo los conectores tambin deben
			propagar el borrado al exterior */
		virtual int eliminarSuscripcionesAElemento (Elemento *e);
		
		
		/*	Los conectores solo hacen UNA conexion por lo que es
			util disponer de estos metodos tambien aqui*/
		Elemento* getElementoSuscriptor() { 
			return suscripciones[0]->getElementoSuscriptor(); 
		}
		Elemento* getElementoAvisador  () { 
			return suscripciones[0]->getElementoAvisador();   }
		int		  getPosEntradaSuscriptor () { 
			return suscripciones[0]->getPosEntradaSuscriptor();  }
		int		  getPosSalidaAvisador	   () { 
			return suscripciones[0]->getPosSalidaAvisador();	   }
	private:
		bool esta_libre;
};


#endif
