/*	AVISO: Se pueden modificar las constantes de tamao, MAX_LONG_VECTOR_ENTRADAS
	y otras, sin que la aplicacin falle, sin embargo el rendimiento es un poco
	peor. Una posible optimizacin residira en mejorar los recorridos de
	los vectores, ya que creo que a veces se recorren vectores hasta el final
	de forma innecesaria. Un claro ejemplo est en el recorrido del vector
	de suscripciones, que funciona examinando TODAS las posiciones. Quiz
	se podra llevar una cuenta de cuantas suscripciones hay y examinar
	solo las necesarias y no todas. */


/*	Si vas a modificar el programa ten cuidado por favor. He probado
	muchas cosas muchas veces y en general he eliminado tantos errores como
	he podido. Sin embargo, y como ya sabrs, futuro padawan ingeniero, 
	nunca se eliminan los errores del todo. Antes de ponerte a reimplementar
	alguna cosa asegrate de que comprendes todas las ramificaciones. Comprueba
	todos los mtodos que llaman al mtodo que vas a modificar y prueba todas
	las llamadas al cdigo modificado. */
	
	
#ifndef _constantes_
#define _constantes_

/*	Comentar las siguientes linea cuando se desee eliminar la informacion
	extra aadida para la depuracion*/
//#define DEBUG 
//#define DEBUG_CONTADOR
//#define DEBUG_MOTOR
//#define DEBUG_BIESTABLE
//#define DEBUG_PULSADOR
//#define DEBUG_LAMPARA
//#define DEBUG_SISTEMA

/*	Se pueden construir elementos del tamao que se desee
	aunque para simplificar se han puesto estos maximos*/
#define MAX_LONG_VECTOR_ENTRADAS 500
#define MAX_LONG_VECTOR_SALIDAS	 500


/*	Una parte de estas entradas se reservan a las usadas por 
	las entradas clsicas de todo elemento, en concreto, las siguientes*/

#define POS_ENABLE 	0 	/*Para habilitar un elemento*/
#define POS_RESET	1	/*Para reinicializar un elemento*/
#define POS_KEEP	2	/*Para forzarlo a que conserve el estado*/

/*	En el vector de entradas la primera entrada "util" es esta*/
const int POS_ENTRADA=3;

/*	En el vector de salidas la primera salida "util" es esta*/
const int POS_SALIDA=0;

/*	Numero maximo de elementos que un elemento puede tener conectados*/
#define MAX_SUSCRIPCIONES 50	

#define MAX_NUM_ELEMENTOS_POR_SISTEMA 100

/*	Longitud maxima del nombre de un elemento*/
#define MAX_LONG_NOMBRE_ELEMENTO	30

#define ENTRADA_CAMBIADA		0
#define POS_ENTRADA_INVALIDA	-10
#define POS_SALIDA_INVALIDA		-20
#define ELEMENTO_INVALIDO		-30
#define DEMASIADAS_SUSCRIPCIONES -40
#define TIPOS_NO_COINCIDEN		-50
#define ERROR_DE_BIESTABLE		-55
#define ELEMENTO_NO_ENCONTRADO	-60
#define PUNTERO_NULL			-70
#define SUSCRIPCION_BORRADA		10
#define SUSCRIPCION_NO_EXISTIA	-65
const bool CONEXION_ACTIVA=true;
const bool CONEXION_INACTIVA=false;

#define VOLTAJE_ACTIVO		5.0
#define VOLTAJE_INACTIVO	0.0



/* La diferencia entre dos float debe ser menor que este valor*/
#define MARGEN_ACEPTABLE 0.01

/*	Longitud maxima que puede tener una palabra para hablar del giro
	de un motor. En general se usa "stop" "cw" y "ccw" asi que 5 suele bastar*/
#define MAX_LONG_PALABRA_GIRO 5

#define	NOMBRE_ENTRADA_R_BIESTABLE		"Entrada R"
#define NOMBRE_ENTRADA_S_BIESTABLE		"Entrada S"
#define NOMBRE_SALIDA_Q_BIESTABLE		"Salida Q"
#define NOMBRE_SALIDA_Qneg_BIESTABLE	"Salida Qneg"

#define ELEMENTO_ELIMINADO 					90
#define SUSCRIPCION_ELIMINADA				92
#define NO_SE_ENCONTRO_NADA_PARA_ELIMINAR 	95

enum TipoAccion{
	CONECTAR_ENTRADAS_DEL_ELEMENTO = 1,
	CONECTAR_SALIDAS_DEL_ELEMENTO
};

#define 	NINGUNO  		-1
#define 	PULSADOR 		0
#define		TEMPORIZADOR	1
#define 	RELE			2
#define		CONTADOR		3
#define		ELECTROIMAN		4
#define		REED			5
#define		ZUMBADOR		6
#define		BIESTABLE		7
#define		FOTOSENSOR		8
#define		LAMPARA			9
#define		MOTOR			10
#define		SISTEMA			11

#define		TOTAL_ELEMENTOS	12

#endif
