#include "elemento.h"
#include "constantes.h"
#ifndef _temporizador_
#define _temporizador_


/*	El Temporizador es un poco especial, y por sus caractersticas
	no puede reaprovechar de la clase padre (ElementoSimple) tanto
	como sera deseable.*/
	
class Temporizador : public Elemento {
	public:
		Temporizador();
		Temporizador(Voltaje* vEntradaInicial, Voltaje* vSalidaInicial,
					Voltaje* vActivacion, Voltaje* vSalidaTimeout, 
					unsigned long tiempo);
		void 	reset();
		void 	construir		(DOMElement* nodo);						
		virtual DOMElement*		getNodo();
		
		Voltaje*	getVoltajeEntradaInicial	();
		Voltaje*	getVoltajeSalidaInicial		();
		Voltaje*	getVoltajeActivacion		();
		Voltaje*	getVoltajeSalidaEnTimeout	();
		bool		esVoltajeDeActivacion		(Voltaje* v);
		unsigned long int 	getTiempoMax		();
		unsigned long int	getTiempoActual		();
		
		int		setEntrada 					(Senal* s, int posicion=POS_ENTRADA);			
		void 	setVoltajeEntradaInicial	(Voltaje*);
		void	setVoltajeSalidaInicial		(Voltaje*);
		void 	setVoltajeActivacion		(Voltaje*);
		void 	setVoltajeSalidaEnTimeout	(Voltaje*);
		void	setTiempoMax				(unsigned long int);
		
		
		void 	actualizar					();
		
		virtual NodoXML getXML ( DOMImplementation* impl );
	protected:
		
		DOMElement*		getNodo(char* nombreElemento);
		
		Voltaje*	voltajeEntradaInicial;
		Voltaje*	voltajeSalidaInicial;
		Voltaje*	voltajeActivacion;
		Voltaje*	voltajeSalidaEnTimeout;
		/*	Esta variable almacena el tiempo que tiene que esperar
			el temporizador hasta cambiar su salida*/
		unsigned int long tiempoMax;
		
		unsigned int long tiempoActual;
		
		/*	Esta variable indica si el temporizador est activado
			y esperando que pase un tiempo determinado para propagar
			su salida */
		bool	estoyActivado;
		/*	Aqui se almacenan los nodos XML que se 
			escribirn cuando sea necesario*/
		DOMElement*	nodoVoltajeEntradaInicial;
		DOMElement*	nodoVoltajeSalidaInicial;
		DOMElement*	nodoVoltajeActivacion;
		DOMElement*	nodoVoltajeSalidaEnTimeout;
		DOMElement*	nodoTiempo;
		
};



#endif
