#include "unit++.h"
#include "reed.h"
#include "parser.h"

using namespace unitpp;

namespace
{
	
	class PruebaXMLReed : public suite
	{
		void PruebaValoresReed()
		{
			bool ficheroCorrecto = false;
			Parser* p=new Parser();
			Sistema* sistemaParseado;
			/* 	Se comprueba primero un fichero con un 
				sistema simple que contiene un reed*/
			cout << "Comprobando reed.xml\n";
			ficheroCorrecto	=	p->esValido ("xml\\reed.xml");
			cout << "reed.xml es valido, extrayendo sistema...\n";
			if (ficheroCorrecto)
			{
				cout << "reed.xml es valido, extrayendo sistema...\n";
				sistemaParseado=p->getSistema();
				cout << "Sistema XML Reed obtenido\n";
				/* 	En este punto deberia haber un reed dentro del
					sistema. El reed de este fichero se llama 
					"sensormagnetico" (no modificar los ficheros de test del
					directorio xml) */
				Reed* r = (Reed*)
					sistemaParseado->getRefElementoPorNombre("sensormagnetico");
				cout << "Examinando voltajes" << endl;
				/* Construimos los valores de comparacion a mano...*/	
				Voltaje*  	v1 = new Voltaje  (0.0);
				Voltaje*  	v2 = new Voltaje  (9.0);
				Magnetismo* m1 = new Magnetismo (false);
				Magnetismo* m2 = new Magnetismo (true);
				
				cout << "Senales construidas\n";			
				//Valores que leemos y compararemos con los construidos
				//para comprobar si son iguales
				Voltaje*	vSalidaReposo;
				Voltaje*	vSalidaActivacion;
				Magnetismo* magEntradaReposo;
				Magnetismo* magEntradaActivacion;
				
				
				/* 	...y comparo esos valores con los leidos del fichero...*/
				
				vSalidaReposo = r->getVoltajeSalidaReposo();
				assert_eq ("(XML) Voltaje salida reposo en reed", 
					vSalidaReposo->getValor(), v1->getValor() );
					
				vSalidaActivacion = r->getVoltajeSalidaActivacion();
				assert_eq ("(XML) Voltaje salida activacion en reed", 
					vSalidaActivacion->getValor(), v2->getValor() );
				
				cout << "Voltajes comparados\n";
				magEntradaReposo = r->getMagnetismoReposo();
				assert_eq ("(XML) Magnetismo en reposo de reed", 
					magEntradaReposo->getValor(), m1->getValor() );
				
				magEntradaActivacion = r->getMagnetismoActivacion();
				assert_eq ("(XML) Magnetismo de activacion de reed", 
					magEntradaActivacion->getValor(), m2->getValor() );
				cout << "Magnetismos comparados\n";
				p->escribir(r, "xml-resultadoTest-xmlreed.xml");
				delete p;				
			}	/* Fin del if que comprueba si el fichero es correcto */
		}
		public:
			PruebaXMLReed() : suite ("Prueba del XML del reed")
			{
				add ("PruebaXMLReed", testcase (this,
					"PruebaXMLReed", 
					&PruebaXMLReed::PruebaValoresReed) );
				
				suite::main().add("PruebaXMLReed", this);
			}
	};
	PruebaXMLReed *prReed=new PruebaXMLReed();	
}
